_gpg-sq() {
    local i cur prev opts cmd
    COMPREPLY=()
    cur="${COMP_WORDS[COMP_CWORD]}"
    prev="${COMP_WORDS[COMP_CWORD-1]}"
    cmd=""
    opts=""

    for i in ${COMP_WORDS[@]}
    do
        case "${cmd},${i}" in
            ",$1")
                cmd="gpg__sq"
                ;;
            *)
                ;;
        esac
    done

    case "${cmd}" in
        gpg__sq)
            opts="-s -b -e -c -d -k -K -v -q -n -i -a -o -z -r -u -h -V --sign --clear-sign --detach-sign --encrypt --symmetric --decrypt --verify --list-keys --list-signatures --check-signatures --fingerprint --list-secret-keys --generate-key --quick-generate-key --quick-add-uid --quick-revoke-uid --quick-set-expire --full-generate-key --generate-revocation --delete-keys --delete-secret-keys --quick-sign-key --quick-lsign-key --quick-revoke-sig --sign-key --lsign-key --edit-key --change-passphrase --export --send-keys --receive-keys --search-keys --refresh-keys --import --update-trustdb --print-md --server --tofu-policy --x-sequoia-parcimonie --verbose --quiet --options --log-file --default-key --encrypt-to --group --openpgp --dry-run --interactive --armor --output --textmode --auto-key-locate --auto-key-import --include-key-block --disable-dirmngr --recipient --local-user --x-sequoia-autostart-parcimonie --help --version [ARGS]..."
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 1 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --sign)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -s)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --clear-sign)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --detach-sign)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -b)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --encrypt)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -e)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --symmetric)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -c)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --decrypt)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -d)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --verify)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --list-keys)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -k)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --list-signatures)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --check-signatures)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --fingerprint)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --list-secret-keys)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -K)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --generate-key)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --quick-generate-key)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --quick-add-uid)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --quick-revoke-uid)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --quick-set-expire)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --full-generate-key)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --generate-revocation)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --delete-keys)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --delete-secret-keys)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --quick-sign-key)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --quick-lsign-key)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --quick-revoke-sig)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --sign-key)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --lsign-key)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --edit-key)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --change-passphrase)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --export)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --send-keys)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --receive-keys)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --search-keys)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --refresh-keys)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --import)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --update-trustdb)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --print-md)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --server)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --tofu-policy)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --x-sequoia-parcimonie)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --verbose)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -v)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --quiet)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -q)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --options)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --log-file)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --default-key)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --encrypt-to)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --group)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --openpgp)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --dry-run)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -n)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --interactive)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -i)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --armor)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -a)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --output)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -o)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --textmode)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -z)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --auto-key-locate)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --auto-key-import)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --include-key-block)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --disable-dirmngr)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --recipient)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -r)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --local-user)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -u)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --x-sequoia-autostart-parcimonie)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
    esac
}

if [[ "${BASH_VERSINFO[0]}" -eq 4 && "${BASH_VERSINFO[1]}" -ge 4 || "${BASH_VERSINFO[0]}" -gt 4 ]]; then
    complete -F _gpg-sq -o nosort -o bashdefault -o default gpg-sq
else
    complete -F _gpg-sq -o bashdefault -o default gpg-sq
fi
